'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scopeTest = scopeTest;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    cls.apply(this, arguments);
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

var UngrantedScopeError = exports.UngrantedScopeError = function (_extendableBuiltin2) {
  _inherits(UngrantedScopeError, _extendableBuiltin2);

  function UngrantedScopeError(missingScopes) {
    _classCallCheck(this, UngrantedScopeError);

    var _this = _possibleConstructorReturn(this, (UngrantedScopeError.__proto__ || Object.getPrototypeOf(UngrantedScopeError)).call(this, 'Some scopes are not granted'));

    _this.name = UngrantedScopeError.name;
    var error = new Error(_this.message);
    error.name = _this.name;
    _this.stack = error.stack;
    _this.missingScopes = missingScopes;
    return _this;
  }

  return UngrantedScopeError;
}(_extendableBuiltin(Error));

function buildTable(scopes, ignoreCase) {
  var table = {};
  var length = scopes.length;
  for (var i = 0; i < length; i += 1) {
    var scope = scopes[i];
    table[ignoreCase ? scope.toLowerCase() : scope] = scope;
  }
  return table;
}

function scopeTest(scopes) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var ignoreCase = !!options.ignoreCase;
  var requiredScopesTable = buildTable(options.requiredScopes || [], ignoreCase);
  var requiredScopes = Object.keys(requiredScopesTable);
  var grantedScopesTable = buildTable(scopes, ignoreCase);
  var grantedScopes = Object.keys(grantedScopesTable);
  var missingScopes = [];
  var requiredScopesLength = requiredScopes.length;

  for (var i = 0; i < requiredScopesLength; i += 1) {
    var requiredScope = requiredScopes[i];
    var grantedScopesLength = grantedScopes.length;
    var granted = false;
    for (var j = 0; j < grantedScopesLength; j += 1) {
      if (grantedScopes[j] === requiredScope) {
        granted = true;
        break;
      }
    }
    if (!granted) {
      missingScopes.push(requiredScopesTable[requiredScope]);
    }
  }
  if (missingScopes.length) {
    throw new UngrantedScopeError(missingScopes);
  }
}